Welcome to NU-Tech

Introducing NU-Tech

 Top Next
Thank you for trying NU-Tech!

This Help file provides an introduction to the NU-Tech environment and its different uses. It is a common experience that reading manuals is very annoying, and the probably most frequent approach to a new software is to run it and guess. We developed NU-Tech with this in mind: we hope you will never need to resort to this manual but should you need some explanation, you’ll findt it here. You can also visit www.nutechdsp.com to get more information and material.


Overview

 Previous Top Next
NU-Tech is a platform aimed to real-time scenarios, where a strict control over time and latencies is paramount. When developing dsp algorithms, the main problem to face is: where do I test them? What platform gives me the freedom to write my code in ANSI C/C++ and test the final result in a straight manner? And more: DSP or PC?
Obviously our answer is: PC running NU-Tech. If your goal is implementing a new algorithm, no matter what kind of hardware the final target will be, NU-Tech offers all the benefits you need. During the early stage of the development, you will be able to evaluate the feasibility of a project saving time and money.
The user interface is simple and intuitive: a work area hosts the NUTSs (NU-Tech Satellites) that can be interconnected to create very complex networks (limited only by the power of the computer). A basic set of logical and dsp NUTSs is provided and an SDK shows how to develop your own Satellites in a few steps. That means you can strictly focus on your piece of code because all the rest is managed by the environment.
The generation of a run-time (.exe file) allows you to “freeze up” your configuration (NUTSs network) and distribuite it to your customer as a demo or as a final application. It turns out that NU-Tech can be at the same time a developing platform for internal use, but also a powerful tool for creating and distributing your finite applications.

The core of NU-Tech has been thought in a modular way so to “connect” to the external world by means of interchangeable drivers. For real-time applications ASIO 2.1 has been adopted, providing compatibility with all soundcards supporting the protocol.
A switch to a different driver turns NU-Tech into another tool but your NUTSs are still there and you can always take advantage of their functionalities.

New drivers will be continuously added in the future giving the platform even more flexibility. Further details about the product and new releases can be found on the NU- Tech Web Site.


Copyright, License, Warranty

COPYRIGHT-LICENCE-WARRANTY

Legal Notices

Steinberg Media Technologies AG.

VST is a registered trademark of Steinberg Media Technologies AG.

ASIO is a trademark of Steinberg Media Technologies AG.

All other trademarks are property of their respective owners.

DISCLAIMER OF WARRANTY

THIS SOFTWARE AND THE ACCOMPANYING FILES ARE PROVIDED "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OR MERCHANTABILITY OR ANY OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED. NO WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.

ANY LIABILITY OF THE PROVIDER WILL BE LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.

COPYRIGHT

WITHOUT LIMITING THE RIGHTS UNDER COPYRIGHT, NO PART OF THIS DOCUMENT MAY BE REPRODUCED, STORED IN OR INTRODUCED INTO A RETRIEVAL SYSTEM, OR TRANSMITTED IN ANY FORM OR BY ANY MEANS (ELECTRONIC, MECHANICAL, PHOTOCOPYING, RECORDING, OR OTHERWISE), OR FOR ANY PURPOSE, WITHOUT THE EXPRESS WRITTEN PERMISSION OF LEAFF ENGINEERING.

LEAFF RESERVES THE RIGHT TO MODIFY THE SOFTWARE AND RELATIVE MANUAL WITHOUT PRIOR NOTIFICATION TO ANY APPLICANT. LEAFF ALONE MAY INTERPRET AND APPLY REQUIREMENTS AND PROCEDURES SET FORTH IN THIS MANUAL.


Starting a Mode

When application is launched, a form appears (see figure) asking to select a "Mode".
A NU-Tech Mode can coincide with the audio driver for example ASIO or DirectSound, but different "Modes" can be created for specific needs.
In fact NU-Tech has been developed to represent a host for interchangeable drivers and, obviously, a compatible hardware must be installed on the machine.

“A driver is, in general, a software layer providing all the information on a specific hardware needed to the operating system to communicate with.”

Following a description of the available Modes:

Asio (Audio Streaming Input Output) is “© Steimberg Media Technologies GmbH” copyright. It is a software interface to the hardware driver, addressing the problem of high data throughput, synchronization and low latency in multichannel scenarios. Nowadays, the most part of professional sound-cards supports ASIO.

DirectSound® is part of Microsoft® DirectX® APIs. It is a support for developing high-performance audio applications with high level of control over hardware resources.

Trigger: this mode has been specifically designed for video streaming applications where synchronization between audio and video tracks is essential.

Offline: to perform offline processing tasks, NU-Tech can run without any audio support, fully exploiting the power of the PC.

Remote Control: to connect to another NU-Tech station on the same network and to perform tasks by locally "virtualizing" the remote Board. See "NU-Remote section" .

The standard version of NU-Tech is aimed to real-time low-latency audio applications, so the support is limited to audio soundcards; it is possible to load further drivers adding new capabilities and turning NU-Tech into a different tool.


Loading NUTSs

Adding NUTSs

NUTSs are generated as simple .dlls. When NU-Tech is installed, a folder called “Plug-In” is created within:

“….\Program Files\Leaff\NU-TECH\”.

All NUTSs files must be placed under that directory in order to be loaded at start up.
New folders can be freely created within the PlugIn directory to contain custom NUTSs developed by the user or to group them according to a different classification.

Note: The tree-view is directly bound to the PlugIn directory reflecting its hierarchy.


Overview

First of all, what is a NUTS? It’s an acronym standing for “NU-Tech Satellite”. The graphical representation is a white rectangle with a variable number of pins, and it is the elementary unit of a network (see "THE NUTSs and the Graphical conventions" ). From a developer point of view it is nothing but a plug-in, a piece of code; a basic set of NUTSs is provided together with the software but custom plug-ins can be created and loaded in very few steps. For further information about this topic, please refer to the NU-Tech Web Site or download the NUTS SDK 2.0.


The Lateral Multitab Pane

On the left side of the window is located a multi tab pane ( maked as 1 ) containing:

THE TOOL AND COMMAND BAR

Provides quick access to commonly used tasks; for a complete description see the section "The Tool Bar" .

THE NUTSs TREE

A tree-view contains the available NUTSs. They can be grouped into folders following the specific functionality. To add a NUTS to the work area, double-click or drag it from the tree to the desired position on the board.
Note: The tree-view reflects the directory structure created when installing NU-Tech; on how to load new NUTSs refer to the section "Loading NUTSs" .

THE NU-MODULE TREE

A tree-view shows the modules that can be loaded on the Board. For a complete discussion about the NU-Modules see section " NUModules ".

THE VST TREE

A tree-view shows a list of VST plugins that NU-Tech has discovered on the machine. VST plugins can be loaded on the Board and used as normal NUTS'.


The Board

The “Board” is the work area where all the actions take place marked as 2 . Here you add and connect together NUTSs creating the desired network. If the working driver is an audio driver ( see section "Starting a Mode" ), you can consider the board in the “middle of your soundcard”. On the left side are located the pins (yellow squares) representing the inputs and on the right side the outputs. Obviously, the number of pins depends on the hardware installed on the computer; NU-Tech will retrieve such information from drivers at start up and will set up the graphical interface.


The Transport panel

A floating window ( marked as 4 ) to control playback and to show CPU usage. See section “ Using the Transport Panel ”.


The Bottom Multitab pane

At the bottom of the window is visible another multitab panel ( marked as 3 ) where can be found:

Output tab

Lists chronologically actions and events.

NU-Module tab

Lists the NU-Module/s loaded on the Board.
The right side of this tab is dedicated to a network table listing all the discovered NU- Tech stations (s).

NUTSs tabs

Each NUTS can expose controls, parameters or internal variables for monitoring and functioning purposes. Note that in NUTS SDK these tabs are called RTWatch (Real Time Watch) windows. See "The RealTime Watch" .


The RealTime Watch (RTWatch)

As seen in " Overview ", the NUTSs are not compelled to provide a settings window. To ease the developer in quickly creating new NUTSs without having to deal with GUI programming, NU-Tech provides a window called "RealTime Watch" to be associated to each NUTS. In brief, the developer can choose, by code, to "expose" some NUTS' internal variables on this window, and effectively control his plug-in. The window is nothing but a tab on the " The Bottom Multitab pane " that automatically appears when at least one parameter is exposed by the developer. When the user double-clicks on a NUTS, the associated tab (if any) immediately jumps in foreground.

The above picture shows the Gain tab, which is an example of a NUTS without a settings window but yet letting the user control data type and "gain" parameter. To deal with this topic exhaustively, please refer to NUTS SDK ( www.nutechdsp.com/developers )


Overview

Every NUTS appears on the board as a white rectangle, with the distinctive name reported on the upper part; a progressive index (the number between brackets) is automatically generated for multiple istances of the same NUTS.
Every NUTS can have associated a settings window accessible by a double click on the white area. Custom plug-ins are not compelled to expose such window.

As can be noticed from the above pictures, pins color change to remark the different data types that can be set through the combos. See section "Setting Data Type” for all the details. Moving the mouse pointer over the pins, a tool tip appears to summarize the name of the NUTS, data type details and framesize.
An “x” button on the right bottom end of the NUTS, let the user remove it from the board. The shortcut "Ctrl + Delete" can also be used to remove one or more NUTSs at once.

The above picture shows how the NUTS can appear on the Board and their naming convention.


Creating a simple network of NUTSs

Creating a network of NUTSs is quick and easy.
Add to the board the NUTSs you need by choosing from the tree-view.
To connect two NUTSs: left click on the output pin of the first NUTS and, keeping the mouse button down, drag a line to the input pin of the second NUTS and release

Notice that when the mouse pointer enters the sensitive area of a pin, its color turns to blue.

To remove a link simply double-click on the desired pin.

Note: only output and input pins of different NUTSs can be connected. Other combinations are not allowed (input-input, output-output, feed-back connection on the same NUTS).

Note: NU-Tech performs a data type coherence check between pins before they can be connected. See also section "Pin Type Propagation" for further details.


Easy-Connect feature

When a considerable number of pins has to be connected, try the following to shorten the operation:
· left click on the pin
· keep pressed Ctrl button on the keyboard
· drag the link on the destination pin
· release the mouse button


Setting the Data Type

Nearly any NUTS can be set to change the data type and its structure; the following picture shows two combo boxes and an edit box (Split NUTS as an example).

The first combo sets the data structure among the following:

PlayBuffer: the NUTSs handle blocks of data of the same length of Buffer Size. This value can be changed (see the section “Using the Tool Bar”) but it depends on the combination hardware/driver installed on the computer. As an example consider a FileRead connected to a Gain which sends signal to the audio output, with a Buffer Size set to 4096. It means that FileRead will send buffers of 4096 samples to Gain NUTS; each buffer will be moltiplied by a gain factor and sent to the output.

Scalar: The NUTS process blocks of only 1 sample of data. It means that every (Buffer Size/SampleRate) seconds only one sample of data will be sent from a NUTS to the next.

Vector: The block of data can be of a length determined by the user. For example a Vector length of 100 samples and a Buffer Size of 1024, implies that every (1024/SampleRate) seconds a block of 100 sample are processed.

Varlen: The length of a block of data processed by a NUTS can vary during streaming. As an example, consider an asyncronous communication during which the amount of valid data received from the NUTS is not constant.

The second combo set the data precision according to the following options:

Integer 8 bit
Integer 16 bit
Integer 32 bit
Float 32 bit
Double 64 bit

The edit box is enabled only when Vector type is set: here the user can indicate the length of the vector for the data to be processed.

Note:
BufferSize and SampleRate are strictly related to the hardware installed on the PC and to the driver provided. In fact the minimum latency obtained depends on the minimum BufferSize supported from the hardware.

Note:
The PlayBuffer data structure can be seen as a “container” with respect to bit depth supported by the soundcard. For example a 16 bit inputs sound card sends to NU-Tech buffers of integer values ranging from 32767 to -32768; these buffers are stored in PLAYBUFFER structure of floating point double precision (64 bit). Before the processed data are passed to the sound card outputs (that is data exit from NU-Tech), they are scaled down to integer 16 bit.


Pin Type Propagation

When trying to connect two pins of different type (data format, data precision or data length), NU-Tech dispatches a message attempting to adjust the PinType of all the connected NUTSs in the chain. In order to successfully complete the conversion, each NUTS should contain the code to handle such a message (see SDK Addendum ver. 1.0).


NUTS Rename feature

Each NUTS on the board can be renamed by right-clicking on the NUTS and selecting “Rename NUTS” from the contextual menu. The new name will be mantained when saving a Configuration.


XML Configuration format

Configurations (network of NUTSs) are now saved in a new format using an XML description. The file contains all the environment information, a detailed description of each NUTS and the network connections. When a new Configuration is saved, a short text description can be added to the file.


Shared Memory

All the NUTSs on the Board can get access (register) to a common memory area in order to share data or information. A suitable mechanism has been arranged in order to notify each registered NUTSs of the Shared Memory modifications (See SDK Addendum ver. 1.0 for details).


Overview

1. Undo Action.
2. Redo Action
3. Ungroup NUTSs. Can be also done by double clicking on a “Grouped” NUTS.
4. Group a bunch of selected NUTSs.
5. Copy a group of selected NUTSs.
6. Paste the copied NUTSs on the board, preserving the original respective placement.
7. Delete the selected NUTSs.
8. The Settings Dialog .
9. Save a “configuration” i.e. a network of NUTSs and the settings of each.
10. Load a saved “configuration”.
11. Run Nu-Sync feature for NUTS synchronization.
12. Clean up the board to start a new project.
13. Open a Dialog window to create a run-time.


The Settings Dialog

Pressing button The Settings Dialog in Toolbar image, the Settings Dialog appears.

“Driver” tab:

Here are reported information about the Soundcard/s installed.
Choose a driver type from the drop-down list to select a driver model to be used for playing back and recording.
SampleRate and FrameSize can also be set. These values are strongly related to the hardware/driver combination available. Depending from the driver loaded, the SoundCard tab can change: an example for the Asio driver is reported.
Since every ASIO soundcard has its own control panel, a button “ControlPanel” is present to get access to it.
Note that FrameSize affects overall performances: the lower this value is set, the higher the cpu load will be. However, setting high values will increase the input- output latency. The right buffer size should be a tradeoff between CPU power available and algorithm constraints.
Software Buffer: This feature is available in ASIO mode only.
By activating this feature the user can insert an arbitrary value in “Software Frame Size” edit box. This feature is very useful in case the developer should need a buffer dimension not natively provided by the soundcard driver. The new input/output latency values will be showed.

Inputs/Outputs: the number of channels available on the sound card.
Input Latency: this is the value declared by the driver upon request.
Output Latency:this is the value declared by the driver upon request.

Note: the minimum latency is normally composed of the Frame Size value and additional samples related to the internal architecture of the card. ASIO, being a low level protocol, provides specific APIs to get an exact value from the driver. When working with non-professional cards or non-native ASIO drivers, this value should be verified.

“Performance Viewer” tab:

The lower part of the Transport panel (marked as 4) , contains a viewer reporting on the cpu usage during streaming. A bar, a chart and a numeric representation of the cpu load can be individually switched off.

Edit Connection Lines: connection lines between two pins can be selected by clicking and dragged.

Advanced NUTS copy and paste: when copying a group of NUTSs, also links and NUTSs settings are copied whereas possible.

Undo and Redo: activate the undo/redo feature for most of the operations executed on the board. This feature is automatically deactivated during streaming. History states can be set to Low=10, Normal=40, High=70.

Show Mode Selection….: when NU-Tech is lunched, the splash screen shows a combo box with all available drivers listed. User can choose to show this dialog at every program start up or not.
Show Window contents…..: in order to diminish cpu overhead when moving objects on the screen, for slower machines, the content can be hidden. This is a Windows effect so, when application exits, previous settings are restored.
Activate Advanced features in....: special graphical behaviors are activated on NUTS settings window.
Show Left Multitab window....: when application starts, the left multitab window is locked open.
Show Horizontal Multitab window....: when application starts, the bottom multitab window is locked open.
Refresh NUTS' Tree…..: to refresh directory if new NUTSs are added while NU- Tech is running.

Two labels indicate how many NUTSs are detected in PlugIn directory and how many of them are active. In fact some NUTSs can be compiled in order to work exclusively with a specified " Mode ".


Using the Transport Panel

Overview

The Transport Panel is responsible for starting streaming by pressing the blue "Play" button. It is possible to set the duration of the streaming clicking on one of the two blue arrows:

· arrow 1: only one buffer (frame) is reproduced before streaming stops.
· arrow N: the user sets the number of buffers or the time (in seconds) to program the duration of the streaming. By double-clicking on the white label above the edit box (see "sec" in the picture), one can switch between seconds and frames.

Note: As the streaming is a "buffer-based" process, the duration in seconds could be rounded to the next buffer. For example, 1 second of streaming at a sample rate of 44.1 kHz (i.e. 44100 samples/sec) and buffersize of 2048 samples, would need 44100/2048= 21.5 buffers, rounded to 22 buffers. This would produce a real duration of (2048/44100)*22= 1.022 seconds. Since NU-Tech doesn't apply any additional software buffering, the user is responsible for trimming data when using time units.

The above picture shows the panel aspect during streaming: the blue "play" button has turned into a red "stop" button and the N-arrow has been selected to execute 500 frames of streaming. A display shows time information, frame elapsed over the total, and sample frequency.
The lower part of the panel contains a three-frames display to monitor the cpu usage: a histogram, a numeric value and a chart are continuously updated during streaming (see The Settings Dialog for performances settings).

Note: The displayed CPU usage value, is only related to the NU-Tech process. In particular it considers all the computations executed inside the "Process" function of each NUTS on the Board (see NUTS SDK for details on the "Process" function). In this respect while this monitor could report a near zero CPU percentage (i.e. no processing is being performed), another application running on the same PC could use all CPU power.

Note: When using NU-Tech in " Trigger " mode, another CPU panel appears: the first one being responsible for audio processing and the second one for video processing (see picture below).


MIDI support

This feature is available in Trigger mode only.
The Midi support is provided trough a “Midi IO” NUTS able to detect Midi devices connected to the PC. The messages arriving from the device are listed in the Output tab and made available through the output pin, following the standard Midi format.
A simple application of such interface is represented by the “MidiGain” NUTS where the messages arriving from the “Midi IO” (first Midi channel), are associated to a gain control.


VST plugin

On the lateral multitab pane a “VST Tree” has been added. When NU-Tech is launched, all VST plugins found in the registry are loaded and shown in the tree- view. They can be added on the board togheter with NUTSs and freely connected each other to form a network. They will appear as yellow NUTSs. If a graphical interface exists, it will be accessible as usual by double-clicking on the VST plugin on the Board. The RTW window (Real Time Watch) will add a new tab with all the parameters exposed by the plugin. Changes in RTW parameters will be reflected on the plugin GUI.


Overview

NOT YET DOCUMENTED. SORRY!


Overview

When lunched in “RemoteControl” mode an instance of NU-Tech can connect to another instance of NU-Tech (not running in “RemoteControl” mode) and take control of its Board. The “controller” and the “controlled” must run on pc connected to the the same network (or VPN).


Connecting to a station

In “NUModule” Tab (right pane) a list of the detected stations is shown. The first row is always related to your local station (see IP address and Name). The column “Name” identifies the name of each PC running NU-Tech detected on the network. Double click on the label “Connect” to start a session with the desired station.
The following picture depicts a successful connection to “eeepc”: further connections are blocked during the present session and disconnection is obtained by double clicking again on the lable “Connected”.
As soon as connection is established the controller Board turns to green and the remote Board is locally virtualized: all NUTSs and connections are reproduced on the controller station.

The “NUTS Tree” Tab corresponds to the controlled pc (eeepc in this example): the listed NUTSs are actually present on the hard drive of the controlled pc.

Note

keep in mind that the green Board (controller) is a reproduction of what is happening on the remote (controlled) Board. The soundcard inputs/outputs are physically on the remote pc so they are not available on the local pc. The NUTSs are really added, removed etc., only on the remote Board. The only “living” NUTS on the controller Board is the “RemoteMonitor” (see below).
RemoteMonitor NUTS: to analyze data in a specific node of the remote configuration, a RemoteMonitor NUTS should be added on the Board. Wait some time until the NUTS establishes a valid connection and an input pin is exposed. The RemoteMonitor can operate in three different ways using the Monitor Type parameter:

RemoteMonitor NUTS: to analyze data in a specific node of the remote configuration, a RemoteMonitor NUTS should be added on the Board. Wait some time until the NUTS establishes a valid connection and an input pin is exposed. The RemoteMonitor can operate in three different ways using the Monitor Type parameter:

· Viewer
· FFT
· FileWrite

Note that the “FileWrite” option will cause data to be streamed and saved directly on the controller pc hard drive with possible loss of data - depending on the internet connection and network speed. For critical recordings use the “Shared Folder” described farther on.

Audio Monitoring: activating this option the data entering the RemoteMonitor NUTS will be also reproduced by the sound card on the local pc. Audio is streamed uncompressed.

Frame Latency: when loss of data is detected change this value to increase data
buffering.

Note
The graphical interface provided by some NUTSs will not be visible on the controller machine: the only way to control a NUTS from remote is through the parameters exposed on the RTWatch.


Shared Folder

Shared Folder: this is a folder created on the controlled pc. It can be used to exchange files between local and remote pc.
Ex. if a multichannel recording (high sample rate, high resolution = huge amount of data) is to be performed, it is advised to save the file on the remote pc and just download it afterwards.

Right click on the tab area to access the context menu:
Create New Directory: to create a new folder inside the remote shared folder
Rename File: to rename a file on the remote shared folder
Delete File: to delete a file on the remote shared folder
Import File: to copy a file from the remote folder to the local pc.
Export File: to copy a file from the local pc to the remote shared folder.
Export Directory: to export an entire directory from the local pc to the remote shared folder
You can export any type of file


Overview

This feature allows the user to easily update, distribute and keep synchronized NUTS' between different stations connected to the same network.

The Sync feature is activated by pressing the “Sync” button on the Toolbar. The form depicted above shows a list of the NU-Tech instances active on the network including the “localhost” pc.

STEP 1:

Select the desired station/s by clicking on the first column and press “Next” to proceed.

STEP 2:

A list of all the NUTS' from the selected NU-Tech stations is shown: different criteria can be used to order the list by clicking on each column header.
Use the first column to the left to select a NUTS. The following symbol is shown [image] .
If one or more NUTS' with the same name are present in the list, the symbol [image] will be automatically shown on these NUTS' indicating an overwriting operation.
By clicking on the second column the symbol [image] is shown to indicate the NUTS will be deleted.

The above picture shows an example where the “AudioOverNet” NUTS located in localhost pc (version 0.0.0.0) will overwrite the same NUTS located in LEAFFDAW pc (version 2.1.0.26).
The “AudioTrig” NUTS, located in LEAFFDAW, will be deleted.

The tree view on the right side of the form, is relative to the station selected by using the combo box located on the top right side of the form. double-clicking on a NUTS name in the tree, a white selection appears on the list to highlight the correspondant row.

STEP 3:

Modifications will apply to the selected NU-Tech stations: press "Finish" to execute.

Notice:
There is NO "undo" after "Finish" button is pressed.


Overview

The following sections contain information about the shortcuts and special features you can use to make your work with NU-Tech quicker and easier.

which shortcuts do you want to learn more about?

Mouse

Keyboard

Context Menus


Mouse Shortcuts

Command | Action
Highlight NUTS | Click on NUTS area
Select a NUTS or add a NUTS to a selection | Ctrl+Left Click
Select a NUTS | Left Click and drag to make a selection box including the NUTS/s
Fold windows - reduce to the title bar | Double-Click on windows title bar
Add a NUTS on the Board in default position | Double-Click on the NUTS name in NUTS Tree
Add a NUTS from the tree in a desired position | Select NUTS name on the Tree and drag to the desired position on the Board
Add a Module from the tree | Double-Click on the Module name in NU- Module Tree
Clone a NUTS or a selection | Ctrl+Alt+(Left Click+Drag)


Keyboard

Command | ShortCut
Move between highlighted NUTS | Ctrl+Tab
Select a NUTS or add a NUTS to a selection | Ctrl+Shift+Enter
Copy selected NUTSs | Ctrl+C
Cut selected NUTSs | Ctrl+X
Paste selected NUTSs | Ctrl+V
Delete selected NUTSs | Ctrl+Delete
Group selected NUTSs | Ctrl+G
Ungroup NUTSs | Ctrl+U
Open/Close NUTS Settings Dialog | Ctrl+Enter
Open/Close all NUTS Settings Dialogs | Ctrl+W
Start/Stop Streaming | Ctrl+S
Change Tab in Left Multitab panel | Ctrl+L
Change Tab in Bottom Multitab panel | Ctrl+B
Undo actions | Ctrl+Z
Redo actions | Ctrl+Y


Context Menus

 Previous Top
This menus can be accessed by right-clicking on the interested area.

BOARD
Command | Description
Undo | Undo last action
Redo | Redo action
Paste | Paste a NUTS on the Board.
Select All | Select all the NUTSs on the Board
Deselect All | Deselect all the NUTSs on the Board
Ungroup All | Break up all Groups on the Board
Remove Selected | Delete Selected NUTSs
Remove All | Delete all the NUTSs on the Board
Settings.. | Open The NU-Tech Settings dialog

NUTS
Command | Description
Selected | Select/Deselect a single NUTS
Clone NUTS | Produce a copy of the NUTS and its internal settings
Copy NUTS | Copy a single NUTS
Cut NUTS | Cut a single NUTS
Remove NUTS | Delete a single NUTS from the Board
Disconnect | Disconnect all pins of a NUTS
Copy Selection | Copy all NUTSs in a selection
Cut Selection | Cut all NUTSs in a selection
Create Group | Build a group from a selection of NUTSs
Rename NUTS | Change NUTS default name
.....When one or more Groups are present on the Board
Add NUTS to Group..... | Include a NUTS in a Group
Add Selection to Group.... | Include selected NUTSs in a Group

PIN
Command | Description
Disconnect Pin | Break the link up
Highlight Line | Select a line in order to be moved.

GROUP
Command | Description
Ungroup | Break up a Group
Copy Group | Copy a Group
Cut Group | Cut a Group
Remove Group | Delete a Group from the Board
Disconnect Group | Disconnect all pins
Create a New Group | Build Group with a new index, when the selection already contains a Group. This operation is not reversible.
Extract NUTS | Extract a NUTS without breaking the Group up.
Add Group To Group | Include a Group in another Group preserving the index. This operation is not reversible.

NUTS' TREE
Command | Description
Add NUTS | Add the selected NUTS on the Board.
Refresh List | Update the NUTS list.
Collapse | Collapse an expanded folder.
Expand | Expand a collapsed folder.

RealTime Watch Window (RTWATCH)
Command | Description
Clear All | Delete log events in Output tab
Save to File... | Save to file the content of the selected tab